%define desktop_file 1
%define desktop_file_utils_version 0.2.93
%define build_kde 1
%define build_qt 0

%define qt_version 3.3.0
%define kde_version 3.2.0

Name: wordtrans
Group: Applications/Productivity
URL: http://wordtrans.sourceforge.net
Summary: Multi Language Word Translator for Linux
Version: 1.1pre13
Release: 4
License: GPL
Source: http://wordtrans.sourceforge.net/%{name}_%{version}.tar.gz
Source1: ger-eng.txt
Source2: http://www.aracnet.com/~tyler/IDP/files/French.txt
Source3: http://www.aracnet.com/~tyler/IDP/files/Italian.txt
Source4: http://www.aracnet.com/~tyler/IDP/files/Latin.txt
Source5: http://www.aracnet.com/~tyler/IDP/files/Portuguese.txt
Source6: http://www.aracnet.com/~tyler/IDP/files/Spanish.txt
Source7: QWordtrans.desktop
Source8: wordtrans.conf
Source9: de-en.conf

Patch: wordtrans-1.1pre13-rh.patch
Patch1: wordtrans-1.1pre13-kde3.patch
Patch2: wordtrans-1.1pre12-strip.patch
Patch3: wordtrans-1.1pre13-config.patch
Patch5: wordtrans-1.1pre12-qt.patch
Patch6: wordtrans-1.1pre12-grep.patch
Patch7: wordtrans-1.1pre12-browser.patch
Patch8: wordtrans-1.1pre13-remove-non-ascii-chars.patch
Patch9: wordtrans-1.1pre13-utf8.patch
Patch10: wordtrans-1.1pre13-gcc34.patch

BuildRoot: %{_tmppath}/%{name}-buildroot

%if %{desktop_file}
BuildRequires:desktop-file-utils >= %{desktop_file_utils_version}
%endif

%if %{build_kde}
BuildPrereq: kdelibs-devel >= %{kde_version}
%endif

%if %{build_qt} == 0
Obsoletes: %{name}-qt
%endif

BuildPrereq: qt-devel >= %{qt_version}
BuildPrereq: openjade
BuildPrereq: linuxdoc-tools
BuildPrereq: fribidi-devel

%description
Wordtrans is a front-end for several dictionaries. It supports
some dictionaries in plain text, dict servers and Babylon
Translator's dictionaries.

%package kde
Summary: KDE front-end for wordtrans
Group: Applications/Productivity
Requires: %{name} = %{version}-%{release}

%description kde
Wordtrans is a front-end for several dictionaries. It supports
some dictionaries in plain text, dict servers and Babylon
Translator's dictionaries.

This package contains a KDE front-end for wordtrans.

%package qt
Summary: Qt front-end for wordtrans
Group: Applications/Productivity
Requires: %{name} = %{version}-%{release}

%description qt
Wordtrans is a front-end for several dictionaries. It supports
some dictionaries in plain text, dict servers and Babylon
Translator's dictionaries.

This package contains a Qt front-end for wordtrans.

%package web
Summary: Web front-end for wordtrans
Group: Applications/Productivity
Requires: %{name} = %{version}-%{release}
Requires: php >= 4.2.2-10
Requires: webserver

%description web
Wordtrans is a front-end for several dictionaries. It supports
some dictionaries in plain text, dict servers and Babylon
Translator's dictionaries.

This package contains a Web front-end for wordtrans.

%prep
%setup -q -n %{name}-%{version}
%patch -p1 -b .rh
%patch1 -p1 -b .kde3
%patch2 -p1 -b .strip
%patch3 -p1 -b .rhconfig
%if !%{build_qt}
%patch5 -p1 -b .qt
%endif
%patch6 -p1 -b .grep
%patch7 -p1
%patch8 -p1
%patch9 -p1 -b .utf8
%patch10 -p1 -b .gcc34

%build
QTDIR="" && source /etc/profile.d/qt.sh
make QT_INC="-I$QTDIR/include" QT_LIB="-L$QTDIR/lib" \
     MOC="$QTDIR/bin/moc" CFLAGS="$RPM_OPT_FLAGS" all %{?_smp_mflags}

%if %{build_kde}
make QT_INC="-I$QTDIR/include" QT_LIB="-L$QTDIR/lib" \
     MOC="$QTDIR/bin/moc" CFLAGS="$RPM_OPT_FLAGS" kwordtrans %{?_smp_mflags}
%endif

%if %{build_qt}
make QT_INC="-I$QTDIR/include" QT_LIB="-L$QTDIR/lib" \
     MOC="$QTDIR/bin/moc" CFLAGS="$RPM_OPT_FLAGS" qwordtrans %{?_smp_mflags}
%endif

%install
rm -rf $RPM_BUILD_ROOT

make DESTDIR=$RPM_BUILD_ROOT install

%if %{build_kde}
make DESTDIR=$RPM_BUILD_ROOT install_kde
make -C docs DESTDIR=$RPM_BUILD_ROOT install_kde
%endif

%if %{build_qt}
cp %{SOURCE7} $RPM_BUILD_ROOT%{_datadir}/applnk/Utilities/qwordtrans.desktop
make DESTDIR=$RPM_BUILD_ROOT install_qt
make -C docs DESTDIR=$RPM_BUILD_ROOT install_qt
%else
rm -f $RPM_BUILD_ROOT%{_bindir}/wordtrans
%endif

mkdir -p $RPM_BUILD_ROOT/etc/httpd/conf.d
install -m 0644 %{SOURCE8} $RPM_BUILD_ROOT/etc/httpd/conf.d

rm -rf $RPM_BUILD_ROOT%{_docdir}/kde
install -d $RPM_BUILD_ROOT%{_docdir}/HTML/en
install -d $RPM_BUILD_ROOT%{_docdir}/HTML/es
install -m 644 %{SOURCE1} $RPM_BUILD_ROOT%{_datadir}/wordtrans/de-en.dict
install -m 644 %{SOURCE2} $RPM_BUILD_ROOT%{_datadir}/wordtrans/en-fr.txt
install -m 644 %{SOURCE3} $RPM_BUILD_ROOT%{_datadir}/wordtrans/en-it.txt
install -m 644 %{SOURCE4} $RPM_BUILD_ROOT%{_datadir}/wordtrans/en-la.txt
install -m 644 %{SOURCE5} $RPM_BUILD_ROOT%{_datadir}/wordtrans/en-pt.txt
install -m 644 %{SOURCE6} $RPM_BUILD_ROOT%{_datadir}/wordtrans/en-es.txt

# Remove the sample 50 word dictionary (useless), throw in some good ones
rm -f $RPM_BUILD_ROOT%{_sysconfdir}/wordtrans/d2e.conf \
      $RPM_BUILD_ROOT%{_datadir}/wordtrans/de-es.dict \
      $RPM_BUILD_ROOT%{_sysconfdir}/wordtrans/i2e.conf

for i in fr it pt es; do # Add la when it works
	cat >$RPM_BUILD_ROOT%{_sysconfdir}/wordtrans/en-$i.conf <<EOF
[General]
alias = en-$i
separador = "\t"
utf8 = false
idioma1 = English
idioma2 = @N_$i@
[Diccionarios]
general = %{_datadir}/wordtrans/en-$i.txt
personal = .wordtrans/en-$i.dict
[Opciones]
busqueda_inversa = true
case_sensitive = false
palabras_completas = true
[Iconos]
idioma1 = %{_datadir}/wordtrans/flags/english.png
idioma2 = %{_datadir}/wordtrans/flags/@f_$i@.png
[Descripcion]
lineas = 1
linea0 = <h2>An English-@N_$i@ Dictionary</h2>
EOF
done
perl -pi -e "s,\@N_fr\@,French,g;s,\@f_fr\@,france,g;s,\@N_it\@,Italian,g;s,\@f_it\@,italy,g;s,\@N_la\@,Latin,g;s,\@f_la\@,,g;s,\@N_pt\@,Portuguese,g;s,\@f_pt\@,portug,g;s,\@N_es\@,Spanish,g;s,\@f_es\@,spain,g" $RPM_BUILD_ROOT%{_sysconfdir}/wordtrans/*.conf

cp %{SOURCE9} $RPM_BUILD_ROOT%{_sysconfdir}/wordtrans/

pushd $RPM_BUILD_ROOT%{_docdir}/HTML/en/
ln -s ../../wordtrans-doc/html.en kwordtrans
popd

pushd $RPM_BUILD_ROOT%{_docdir}/HTML/es/
ln -s ../../wordtrans-doc/html.es kwordtrans
popd

pushd $RPM_BUILD_ROOT%{_docdir}/wordtrans-doc/html.fr
ln -nfs ../../wordtrans-doc/html.fr .
popd

rm -f $RPM_BUILD_ROOT%{_docdir}/wordtrans-doc/html.en/html.en \
      $RPM_BUILD_ROOT%{_docdir}/wordtrans-doc/html.en/next.png \
      $RPM_BUILD_ROOT%{_docdir}/wordtrans-doc/html.en/prev.png \
      $RPM_BUILD_ROOT%{_docdir}/wordtrans-doc/html.en/toc.png \
      $RPM_BUILD_ROOT%{_docdir}/wordtrans-doc/html.es/html.es

cp -f $RPM_BUILD_ROOT%{_docdir}/wordtrans-doc/html.es/*.png \
      $RPM_BUILD_ROOT%{_docdir}/wordtrans-doc/html.en

rm -rf $RPM_BUILD_ROOT%{_docdir}/wordtrans-web \
       $RPM_BUILD_ROOT/etc/wordtrans/babylon* \
       $RPM_BUILD_ROOT/etc/wordtrans/de-en.conf.rh \
       $RPM_BUILD_ROOT/etc/wordtrans/dictd.dconf

# use desktop-file-install
%if %{desktop_file}
mkdir -p $RPM_BUILD_ROOT%{_datadir}/applications
%if %{build_kde} == 1
desktop-file-install \
   --vendor kde \
   --delete-original \
   --dir $RPM_BUILD_ROOT%{_datadir}/applications \
   --add-category "Application;Utility;X-Red-Hat-Extra" \
   $RPM_BUILD_ROOT%{_datadir}/applnk/Utilities/kwordtrans.desktop
%endif

%if %{build_qt} == 1
desktop-file-install \
   --vendor qt \
   --delete-original \
   --dir $RPM_BUILD_ROOT%{_datadir}/applications \
   --add-category "Application;Utility;X-Red-Hat-Extra" \
   $RPM_BUILD_ROOT%{_datadir}/applnk/Utilities/qwordtrans.desktop
%endif

rm -frv $RPM_BUILD_ROOT%{_datadir}/applnk
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%dir /etc/wordtrans
%config(noreplace) /etc/wordtrans/*.conf
%config(noreplace) /etc/wordtrans/dict-org.dconf
%if %{build_qt}
%{_bindir}/wordtrans
%endif
%{_datadir}/wordtrans
%{_mandir}/man1/wordtrans.1*
%{_docdir}/wordtrans-doc
%{_docdir}/wordtrans-data
%lang(es) %{_datadir}/locale/es/LC_MESSAGES/wordtrans.mo
%lang(es) %{_datadir}/locale/fr/LC_MESSAGES/wordtrans.mo
%lang(es) %{_mandir}/es/man1/wordtrans.1*

%if %{build_qt}
%files qt
%defattr(-,root,root)
%{_bindir}/qwordtrans
%{_datadir}/applications/*qwordtrans.desktop
%{_datadir}/icons/qwordtrans.*
%lang(es) %{_mandir}/es/man1/qwordtrans.1*
%{_mandir}/man1/qwordtrans.1*
%{_docdir}/wordtrans-qt
%endif

%if %{build_kde}
%files kde
%defattr(-,root,root)
%{_bindir}/kwordtrans
%{_datadir}/applications/*kwordtrans.desktop
%{_datadir}/icons/*/*/apps/*
%{_datadir}/icons/kwordtrans.*
%lang(es) %{_datadir}/locale/es/LC_MESSAGES/kwordtrans.mo
%lang(es) %{_mandir}/es/man1/kwordtrans.1*
%{_mandir}/man1/kwordtrans.1*
%doc %{_docdir}/HTML/en/kwordtrans
%{_docdir}/wordtrans-kde
%lang(es) %doc %{_docdir}/HTML/es/kwordtrans
%endif

%files web
%defattr(-,root,root)
%config(noreplace) /etc/httpd/conf.d/wordtrans.conf 
/var/www/wordtrans

%changelog
* Thu Mar 04 2004 Than Ngo <than@redhat.com> 1.1pre13-4 
- fixed gcc 3.4 build problem

* Fri Feb 13 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Tue Oct 14 2003 Than Ngo <than@redhat.com> 1.1pre13-2
- enable fribidi
- fixes utf8 issue

* Fri Sep 26 2003 Harald Hoyer <harald@redhat.de> 1.1pre13-1
- 1.1pre13

* Wed Jun 25 2003 Than Ngo <than@redhat.com> 1.1pr12-12
- rebuilt

* Tue Jun 17 2003 Than Ngo <than@redhat.com> 1.1pr12-11
- rebuilt

* Wed Jun 04 2003 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Wed May 28 2003 Than Ngo <than@redhat.com> 1.1pr12-9
- bug #90258

* Wed Apr 30 2003 Than Ngo <than@redhat.com> 1.1pr12-8
- add openjade in buildprereq

* Wed Feb 12 2003 Than Ngo <than@redhat.com> 1.1pr12-7
- fix dangling symlink, #84022

* Mon Feb 10 2003 Than Ngo <than@redhat.com> 1.1pr12-6
- obsolete qt frontend
- set correct browser
- add some missing html files

* Sun Feb  9 2003 Than Ngo <than@redhat.com> 1.1pr12-5
- remove duplicate frontend
- ignore comment in dictionary
- add missing config file english-german

* Tue Feb  4 2003 Than Ngo <than@redhat.com> 1.1pr12-4
- add description for Qt frontend, #81870

* Wed Jan 22 2003 Tim Powers <timp@redhat.com>
- rebuilt

* Tue Dec 10 2002 Than Ngo <than@redhat.com> 1.1pr12-2
- add Alias /wordtrans /var/www/wordtrans

* Sun Dec  8 2002 Than Ngo <than@redhat.com> 1.1pr12-1
- 1.1pr12
- remove some patch files, which are in new upstream
- adjust some patch files

* Wed Dec  4 2002 Than Ngo <than@redhat.com> 1.1pr9-11
- use new PHP script style (bug #73513)
- wordtrans-web requires php >= 4.2.2-10, webserver
- clean up specfile
- remove unneeded files
- lib64 issue
- add Buildprereq: qt-devel

* Sat Aug 31 2002 Than Ngo <than@redhat.com> 1.1pr9-10
- Added a security fix from Guardent

* Mon Aug 26 2002 Than Ngo <than@redhat.com> 1.1pr9-9
- fixed a typo bug (bug #71663)

* Thu Aug 22 2002 Than Ngo <than@redhat.com> 1.1pr9-8
- Fixed Makefile issue 

* Sat Aug 10 2002 Elliot Lee <sopwith@redhat.com>
- rebuilt with gcc-3.2 (we hope)

* Tue Jul 23 2002 Tim Powers <timp@redhat.com> 1.1pr9-6
- build using gcc-3.2-0.1

* Tue Jul 09 2002 Than Ngo <than@redhat.com> 1.1pr9-5
- use desktop-file-install

* Fri Jun 21 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Thu Jun 20 2002 Than Ngo <than@redhat.com> 1.1pr9-3
- Don't forcibly strip binaries

* Fri Jun 07 2002 Than Ngo <than@redhat.com> 1.1pre9-2
- fixed double entries (bug #65175)

* Thu Apr 11 2002 Bernhard Rosenkraenzer <bero@redhat.com> 1.1pre8-9
- Rebuild with correct (threaded) Qt
- Fix up default settings

* Tue Apr 9 2002 Than Ngo <than@redhat.com> 1.1pre8-8
- remove duplicate file (bug #62756)

* Tue Apr 2 2002 Than  Ngo <than@redhat.com> 1.1pre8-7
- fix Dangling symlinks (#62557)

* Sun Mar 24 2002 Than  Ngo <than@redhat.com> 1.1pre8-6
- fix bug # 61515

* Tue Mar  6 2002 Than  Ngo <than@redhat.com> 1.1pre8-5
- add wordtrans-1.1pre8-kde3.patch from bero
- fix a cosmetic bug

* Tue Feb 26 2002 Than Ngo <than@redhat.com> 1.1pre8-4
- rebuild

* Fri Jan 18 2002 Than Ngo <than@redhat.com> 1.1pre8-3
- rebuild against qt 3

* Wed Jan  9 2002 Than Ngo <than@redhat.com> 1.1pre8-1
- update to 1.1pre8
- build against qt 3
- clean up patch file for 1.1pre8

* Mon Nov 27 2001 Than Ngo <than@redhat.com> 1.1pre7-1
- update to 1.1pre7
- clean up patch file for 1.1pre7

* Fri Nov 09 2001 Than Ngo <than@redhat.com> 1.0.2pre4-1
- initial rpm for RHL 8.0
